/**
 * @copyright 2020 {@link http://infiniteautomation.com|Infinite Automation Systems, Inc.} All rights reserved.
 * @author Luis Güette
 */

define(['angular', 'require'], (angular, require) => {
    'use strict';

    const POINT_KEYS = {
        'Occupied Units': 'occupiedUnits',
        'Max kW/ton': 'maxKwTon',
        'Consumed Energy': 'energy',
    }

    class KpiIndicatorsController {
        static get $$ngIsClass() {
            return true;
        }

        static get $inject() {
            return ['maPoint'];
        }

        constructor(Point) {
            this.Point = Point;
        }

        $onInit() {
            this.Point
                .buildQuery()
                .eq('deviceName', 'General')
                .limit(1000)
                .query()
                .then(points => {
                    this.points = {}

                    points.forEach(point => {
                        this.points[POINT_KEYS[point.name]] = point
                    })
                });
        }
    }

    return {
        bindings: {
            unitsCount: '<'
        },
        controller: KpiIndicatorsController,
        templateUrl: require.toUrl('./kpiIndicators.html')
    };
});
