/**
 * @copyright 2020 {@link http://infiniteautomation.com|Infinite Automation Systems, Inc.} All rights reserved.
 * @author Luis Güette
 */

define(['angular', 'require'], (angular, require) => {
    'use strict';

    unitFactory.$inject = ['maJsonStore', 'maUtil'];

    function unitFactory(maJsonStore) {

        const defaultProperties = {
            name: '',
            lat: '',
            lon: ''
        };

        const unitsStore = new maJsonStore({
            xid: 'Units'
        });

        class Unit {

            constructor(options) {
                Object.assign(this, angular.copy(defaultProperties), options);
            }

            // lists all the objects contained in the store
            static list() {
                return unitsStore.get().then((store) => {
                    const items = store.jsonData;
                    return Object.values(items).map((item) => new this(item));
                });
            }

        }

        return Unit;

    }

    return unitFactory;
}); // define
